//
#include "base.h"
#include "main.h"
#include "hardware.h"

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

Base::Base(){
	alphatest=0;
	alphafunc=.1f;
	blend=0;
	blendFunc0=1;
	blendFunc1=1;
	depthtest=1;
	depthwrite=1;
	set_color(1,1,1);
	set_xyz(0,0,0);
	on=1;
	size=1;
};
Base::~Base(){};

//------------------------------------------------------------------------

void Base::set_xyz(float inx,float iny,float inz) {
	x=inx;
	y=iny;
	z=inz;
}

//-------------------------------------------------------------------

void Base::set_color(float inr,float ing,float inb) {
	r=inr;
	g=ing;
	b=inb;
}

//-------------------------------------------------------------------

void Base::set_color(float inr,float ing,float inb, float ina) {
	r=inr;
	g=ing;
	b=inb;
	a=ina;
}

//-------------------------------------------------------------------

void Base::set(void) {
	if (alphatest) {
		glEnable(GL_ALPHA_TEST);
		glAlphaFunc(GL_GREATER,alphafunc);
	}
	if (blend) {
		set_blend(blendFunc0,blendFunc1);
		glEnable(GL_BLEND);
	}
	glColor4f(r,g,b,a);
	if (depthtest)   glEnable(GL_DEPTH_TEST);
	if (!depthwrite) glDepthMask(GL_FALSE);
	if (Hw::get()->pref.textures) {
		glEnable(GL_TEXTURE_2D);
	}
}

//-------------------------------------------------------------------

void Base::unset(void) {
	if (alphatest)   glDisable(GL_ALPHA_TEST);
	if (blend)       glDisable(GL_BLEND);
	if (depthtest)   glDisable(GL_DEPTH_TEST);
	if (!depthwrite) glDepthMask(GL_TRUE);
	if (Hw::get()->pref.textures) glDisable(GL_TEXTURE_2D);
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------
//-------------------------------------------------------------------

