// display manager w/            (experimental!)
//   displayable objects w/
//      pointer to geom obj (mesh,billboard,sphere...)
//      pos/orient controller
//      visual attribute handler

#include "disp.h"
#include "hardware.h"
#include "physics.h"

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

DispMan::DispMan(){
	nobjects=0;
	selObject=0;
};
DispMan::~DispMan(){};

//----------------------------------------------------------------------------

void DispMan::reset(void){
	Vis::reset();
}

//----------------------------------------------------------------------------

void DispMan::unset(void){
	Vis::unset();
}

//----------------------------------------------------------------------------

int DispMan::add(BaseObject *base){
	if (nobjects>=25) return -1;
	dos[nobjects].object=base;
	return nobjects++;
}

//----------------------------------------------------------------------------

void DispMan::draw(int n){
	if (n>=nobjects) return;
	if (dos[n].vis.cull==2) {
		if (Hw::get()->screen.viewport->camera.cull(dos[n].place.pos.x,
			                                         dos[n].place.pos.y,
																  dos[n].place.pos.z,size[n])<0) return;
	}
	dos[n].draw(size[n]);
}

//----------------------------------------------------------------------------

void DispMan::update(void){
	int editflag;

	for(int i=0; i<nobjects; i++) {
		editflag=(((Hw::get()->screen.viewport->camera.place.movemode!=MANUAL)|| // not in manual cam mode?
		           (Hw::get()->pref.pause==1))&&   // | paused?
		           (Hw::get()->pref.dialogs==0)&&  // | not dialog ?
					  (i==selObject-1));              // & this 1 selected?
		dos[i].place.update_pos(editflag); // move w/ possible manual control
		dos[i].place.physics->damp(&dos[i].place); // damp
		if (i==selObject-1) { // selected obj?
			dos[i].vis.tex=Texture::textures[Hw::get()->pref.image];
			dos[i].vis.blendFunc0=Hw::get()->pref.blendFunc0; // update prefs->objects
			dos[i].vis.blendFunc1=Hw::get()->pref.blendFunc1;
			dos[i].vis.texmagx=Hw::get()->pref.a1;
			dos[i].vis.texmagy=Hw::get()->pref.a2;
			dos[i].vis.r=Hw::get()->pref.r;
			dos[i].vis.g=Hw::get()->pref.g;
			dos[i].vis.b=Hw::get()->pref.b;
			dos[i].vis.a=Hw::get()->pref.a;
			dos[i].vis.texmagx=Hw::get()->pref.a1;
			dos[i].vis.texmagy=Hw::get()->pref.a2;
		}
	}
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

DispObj::DispObj(){
	object=0;
};
DispObj::~DispObj(){};

float DispObj::polyo=0;

//----------------------------------------------------------------------------

void DispObj::draw(float size){
	vis.set();
	if (vis.polyo==0) polyo=0; // for multipass depthtested blending
	if (polyo){
		glPolygonOffset(polyo,-1);
		glEnable(GL_POLYGON_OFFSET_FILL);
		glDepthMask(GL_FALSE);
	}
	glMatrixMode(GL_TEXTURE);
	glPushMatrix();
		glScalef(vis.texmagx, vis.texmagy, 1);         // texture scaling
		glTranslatef(Hw::get()->time.time*vis.texoffx, // texture scrolling
			          Hw::get()->time.time*vis.texoffy,0);
		glMatrixMode(GL_MODELVIEW);

		glPushMatrix();
			place.set();
			if (object) object->draw(size);
			glPopMatrix();

		glMatrixMode(GL_TEXTURE);
		glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	if (polyo) {
		glDepthMask(GL_TRUE);
		glDisable(GL_POLYGON_OFFSET_FILL);
	}
	polyo-=.1;
}

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

