//
#include "fog.h"
#include "hardware.h"

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

Fog::Fog() {
	fogColor[3]=1;
	fognear=.1;
	fogfar=1;
};
Fog::~Fog() {};

//-----------------------------------------------------------------------------------

void Fog::init(void) {
	glFogi(GL_FOG_MODE,GL_LINEAR);
	glFogfv(GL_FOG_COLOR,fogColor);
	glHint( GL_FOG_HINT,GL_NICEST);
}

//-----------------------------------------------------------------------------------

void Fog::adjust(int flag, float *fognear, float *fogfar) { // tweak fog params
	if (flag&1) { // near
		if      (*fognear<(Hw::get()->screen.nearz+.1)) *fognear=Hw::get()->screen.nearz+.1;
		else if (*fognear>(Hw::get()->screen.farz -.1)) *fognear=Hw::get()->screen.farz -.1;
		if (*fognear>=*fogfar) *fogfar=*fognear+.1;
	}
	if (flag&2) { // far
		if      (*fogfar<(Hw::get()->screen.nearz+.1)) *fogfar=Hw::get()->screen.nearz+.1;
		else if (*fogfar>(Hw::get()->screen.farz -.1)) *fogfar=Hw::get()->screen.farz -.1;
		if (*fogfar<=*fognear) *fognear=*fogfar-.1;
	}
}

//----------------------------------------------------------------------------------

void Fog::set_color(float r, float g, float b) {
	fogColor[0]=r;
	fogColor[1]=g;
	fogColor[2]=b;
	glFogfv(GL_FOG_COLOR,fogColor);
}

//-----------------------------------------------------------------------------------

void Fog::set_distance(float b1, float b2) {
	fognear=b1;
	fogfar =b2;
	glFogf(GL_FOG_START,fognear+Hw::get()->pref.brace);
	glFogf(GL_FOG_END,  fogfar +Hw::get()->pref.brace);
}

//----------------------------------------------------------------------------------
