//

#include "key.h"
#include "main.h"

//--------------------------------------------------------

Key::Key(){
	reset();
};
Key::~Key(){};

//------------------------------------------------------------------------

void Key::reset(void){
	key=skey=alt=control=shift=0;
	for (int i=0;i<4;i++ )arrow[i]=0;
}

//------------------------------------------------------------------------

void Key::set_key(int inkey, int mod){
	key=inkey;
	set_modifiers(mod);
}

//------------------------------------------------------------------------

void Key::set_skey(int inkey, int mod){
	int i=-1;
	skey=inkey;
	switch(inkey) {
		case GLUT_KEY_LEFT:  i=0; break;
		case GLUT_KEY_RIGHT: i=1; break;
		case GLUT_KEY_DOWN:  i=2; break;
		case GLUT_KEY_UP:    i=3; break;
	}
	if (i>=0) arrow[i]=1;
	set_modifiers(mod);
}

//------------------------------------------------------------------------

void Key::unset_skey(int inkey, int mod){
	int i=-1;
	switch(inkey) {
		case GLUT_KEY_LEFT:  i=0; break;
		case GLUT_KEY_RIGHT: i=1; break;
		case GLUT_KEY_DOWN:  i=2; break;
		case GLUT_KEY_UP:    i=3; break;
	}
	if (i>=0) arrow[i]=3;
	alt    =0;
	//control=0;
	shift  =0;
}

//------------------------------------------------------------------------

void Key::sequence(void){
	key=skey=alt=shift=0;
	for(int i=0;i<4;i++){
		if      (arrow[i]==1) arrow[i]=2;
		else if (arrow[i]==3) arrow[i]=0;
	}
}

//------------------------------------------------------------------------

void Key::set_modifiers(int mod) {
	alt    =(mod&GLUT_ACTIVE_ALT)  ?1:0;
	shift  =(mod&GLUT_ACTIVE_SHIFT)?1:0;
	control=(mod&GLUT_ACTIVE_CTRL) ?1:0;
}

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
