#if !defined mesh_h
#define      mesh_h

#include "main.h"
#include "disp.h"

//---------------------------------------------------------------------------------
class Bump;
enum shapenames{SINBUMPS,PARABOLA,CENTERSQ,RINGS,COSBUMP};

class Mesh:public BaseObject{
public:     Mesh();
	virtual ~Mesh();

	float h[100][100][3];
	float n[100][100][6];
	float t[100][100][4];
	float c[100][100][4];
	float i[100][100];
	int   d[100][1];

	int   nodesx, nodesy, meshedit,meshx,meshy, useDisplayList, colors,normals,cullStrip;
	float sizex, sizey, height, min,max, maxheight, texmagx,texmagy, texoffx,texoffy, shapefreq, shapeclipy1;
	float r,g,b,a;
	GLuint listID;

	void draw(float size);
	int collide(Place *place, Physics *physicson);//, Physics *physicson

	void  calc_normal(void);
	void  close(void);
	void  drawv(void);
	void  draw_quads(void);//detail(void);
	void  draw_tris(void);
	void  draw_d(void);
	float get(float x, float y);
	void  getv(float x, float y, float *xi, float *zi);
	void  init(void);
	void  init(Bump *bump, float scale, float offset);
	int   inMesh(float x,float y);
	void  newmesh(int innodesx, int innodesy, float insizex, float insizey);
	void  shape(int type, float shapescale, float offset, float freq);
	void  spherical_map(float scale);
	void  texgen(void);
	void  bumpgen(void);
	void depress(int inx, int iny, int insize, float indepth);
	void  rollup(int type, float f, float radius);
	void calc_shadow(void);
	int cull_strip(int ix, int y0, int y1);
	void do_strip(int ix, int y0, int y1,float r,float g,float b);
};

//---------------------------------------------------------------------------------

#endif

