#if !defined place_h
#define      place_h

#include "main.h"
#include "vector.h"

enum movemodes {HOLD,LOOKAT,ORBIT,MANUAL,LOOKFROM};

//-----------------------------------------------------------------

class Physics;

class Place{ // positional attributes
public: Place();
	virtual ~Place();

	int movemode;
	float shakeampl, shakefreqx, shakefreqy, shakefreqz, mass, momentum, moverate, spinrate;
	Vector pos,vel,acc, orient,spin, lastpos, moveRange,moveCenter, spinRange,spinCenter, shake, to;
	Physics *physics, *lastPhysics;
	Place *otherPlace;

	void cam_adj_x(float in);
	void cam_adj_y(float in);
	void cam_adj_z(float in);
	void move(void);
	void rotate(void);
	void reset(void);
	void set(void);
	void apply_shake(void);
	void update_pos(int viewportn);
};

//-------------------------------------------------------------------

#endif

