//

#include "random.h"
#include "splinter.h"
#include "lightmap.h"
#include "hardware.h"

//-------------------------------------------------------------------

Randoms::Randoms() {
	float array[5][3]={
	//ena int dur
		0, 60,  5, // blank
		0, 60,  1, // lightmap
		1, 80,  2, // splinter
		1, 100,  1,// skip
		1, 120, 1};// option

	splinter=0; lm=0;
	for    (int i=0; i<5; i++) {
		effects[i].enable     =array[i][0];
		effects[i].minInterval=array[i][1];
		effects[i].duration   =array[i][2];
		effects[i].lastTime   =0;
		effects[i].endTime    =0;
		effects[i].on         =0;
	}
};

Randoms::~Randoms() {};

//-------------------------------------------------------------------

int Randoms::update(void) {
	static savec2=.5;
	float time=Hw::get()->time.time;

	switch(test(0)){
		case  1: Hw::get()->pref.blank=0; savec2=Hw::get()->pref.c2; Hw::get()->pref.c2=.1;     break;
		case -1: Hw::get()->pref.blank=1;                            Hw::get()->pref.c2=savec2; break;
	}
	switch(test(1)){
		case 1:
			switch ((int)rndn(18)) { // lm 3rd of time
				default:lm->type=0;  break;
				case 1: lm->type=1;  break;
				case 2: lm->type=2;  break;
				case 3: lm->type=4;  break;
				case 4: lm->type=16; break;
				case 5: lm->type=32; break;
				case 6: lm->type=32|16; break;
			}
			lm->texmagx=pow(rndn(1),3)*10+.1;
			lm->texmagy=pow(rndn(1),3)*10+.1;
			return 2;
			break;
		case -1: lm->type=0; return 2; break;
	}

	switch(test(2)){
		case  1: Hw::get()->screen.capture=1; Hw::get()->pref.blank=0; Hw::get()->pref.c2=.1; break;//.2
		case -1: Hw::get()->screen.capture=0; Hw::get()->pref.blank=1; Hw::get()->pref.c2=.6; splinter->skip=0; break;
	}

	switch(test(3)){
		case 1:
			Hw::get()->screen.capture=1;
			splinter->skipDir=(int)rndn(2)*2-1;
			if (rndn(1)<.4) splinter->skip=1.01;
			else            splinter->skip= .01;
			break;
		case -1: Hw::get()->screen.capture=0; splinter->skip=0; break;
	}

	switch(test(4)){
		case  1: return 1; break;
		case -1: return 0; break;
	}
	return 0;
}

//-----------------------------------------------------------------------------

int Randoms::test(int i) {
	int flag=0;

	if (effects[i].enable){
		if ((rndn(1)<.1*Hw::get()->time.dt)&&((Hw::get()->time.time-effects[i].lastTime)>effects[i].minInterval) ) {
			flag=1;
			effects[i].on=1;
			effects[i].lastTime=Hw::get()->time.time;
			effects[i].endTime=effects[i].lastTime+.6+(1-pow(rndn(1),2))*effects[i].duration;
		} else if ((Hw::get()->time.time>effects[i].endTime)&&effects[i].on) {
			flag=-1;
			effects[i].on=0;
		}
	}
	return flag; // return 1 to turn on, -1 to turn off, 0 for no change
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
