#if !defined vector_h
#define      vector_h

//---------------------------------------------------------

class Vector{
public:

	Vector(float x=0, float y=0, float z=0);
	virtual ~Vector();
	
	float x,y,z;

	void set_xyz(float inx, float iny, float inz);
	void normalize(void);
	float length(void);
	Vector cross_product(Vector v);
	float dot_product(Vector v);

	friend Vector operator+(const Vector& v1, const Vector& v2);
	friend Vector operator-(const Vector& v1, const Vector& v2);
	friend Vector operator*(const Vector& v1, const float& f);
	friend Vector operator/(const Vector& v1, const float& f);

	const Vector& operator+=(const Vector& v);
	const Vector& operator-=(const Vector& v);
	const Vector& operator*=(const float& f);
	const Vector& operator/=(const float& f);
};

//----------------------------------------------------------

#endif

